



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android基本控件之ListView（一）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android基本控件之ListView（一）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-17 20:27:40 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>我们在使用手机的时候，通常看到，像通讯录，QQ列表样式的东西，这里来解释一下，其实那些都是一个ListView</p>
<p>今天，我们就来<strong>详细的讲解一下ListView这个控件</strong></p>
<p>　　<strong>ListView中每条显示的数据都称为一个item</strong>。<strong>每个item都有自己的布局</strong>。</p>
<p>　　在这里，我们就先来实现一个简单的功能，用来解释ListView这个控件</p>
<p>我们就来做一个最简单的<strong>只显示文本和图片的这样的一个ListView</strong>。</p>
<p>　　我先来和大家一起<strong>分析一下</strong>我们应该准备些什么：</p>
<p>　　　<strong>首先</strong>，我们<strong>需要一个主界面布局文件</strong>，并在<strong>布局文件中定义一个ListView</strong></p>
<p>　　　　<strong>然后</strong>，我们<strong>需要创建一个布局文件</strong>，这么布局文件是<strong>每个item的布局</strong>。因为我们只是显示文本和图片，所以我们的这个item的布局就只是一个简简单单的TextView和一个ImageView</p>
<p>　　那么好，我们就<strong>来实现一下，这两个布局文件</strong>。</p>
<p>　　我们先来看<strong>主界面的布局文件</strong>：</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="utf-8"?&gt;<br />
&lt;RelativeLayout xmlns:android="http://schemas.android.com/apk/res/android"<br />
    xmlns:tools="http://schemas.android.com/tools" android:id="@+id/activity_main"<br />
    android:layout_width="match_parent" android:layout_height="match_parent"<br />
    android:paddingBottom="@dimen/activity_vertical_margin"<br />
    android:paddingLeft="@dimen/activity_horizontal_margin"<br />
    android:paddingRight="@dimen/activity_horizontal_margin"<br />
    android:paddingTop="@dimen/activity_vertical_margin"<br />
    tools:context="application.smile.listview.MainActivity"&gt;

    &lt;ListView<br />
        android:id="@+id/listView"<br />
        android:layout_width="match_parent"<br />
        android:layout_height="match_parent"/&gt;<br />
&lt;/RelativeLayout&gt;</pre>
</div>
<p>　　然后，我们再来看一下<strong>每个item的布局</strong>：</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="utf-8"?&gt;<br />
&lt;RelativeLayout xmlns:android="http://schemas.android.com/apk/res/android"<br />
    android:orientation="vertical" android:layout_width="match_parent"<br />
    android:layout_height="match_parent"<br />
    android:padding="10dp"&gt;<br />
    &lt;ImageView<br />
        android:id="@+id/iv_icon"<br />
        android:layout_width="wrap_content"<br />
        android:layout_height="wrap_content"<br />
        android:padding="5dp"<br />
        android:src="@mipmap/ic_launcher"/&gt;<br />
    &lt;TextView<br />
        android:id="@+id/tv_title"<br />
        android:layout_marginTop="10dp"<br />
        android:layout_toRightOf="@+id/iv_icon"<br />
        android:layout_width="match_parent"<br />
        android:layout_height="wrap_content"<br />
        android:text="这是标题"<br />
        android:textSize="20sp"/&gt;<br />
    &lt;TextView<br />
        android:id="@+id/tv_content"<br />
        android:layout_toRightOf="@+id/iv_icon"<br />
        android:layout_below="@+id/tv_title"<br />
        android:layout_width="match_parent"<br />
        android:layout_height="wrap_content"<br />
        android:layout_marginLeft="10dp"<br />
        android:text="这是内容"/&gt;<br />
&lt;/RelativeLayout&gt;</pre>
</div>
<p>这样，我们的两个布局文件就准备完成了。</p>
<p>然后，我们来看<strong>Activity</strong>中是如何实现的。</p>
<p>　　我们<strong>首先</strong>需要几个想要<strong>显示的数据的集合</strong>（或者数组），这里就需要两个了，<strong>一个用来放图片，一个用来放文字</strong></p>
<p>　　<strong>然后</strong>，我们通过老套路，<strong>先找到相应的控件</strong>，<strong>然后设置适配器</strong>，<strong>然后设置点击事件</strong></p>
<p>　　<strong>然后</strong>，因为我们有很多的item需要显示，所以，我们<strong>需要一个适配器</strong>来将我们的数据<strong>显示到屏幕上</strong>。</p>
<p>　　这样，我们就按照我们所想的去<strong>打造这么一个Activity</strong>吧</p>
<div>
<pre class="prettyprint linenums">public class MainActivity extends AppCompatActivity {<br />
        //存储文字的数组<br />
    private String [] names ={"刘备","张飞","诸葛亮","赵云","孙权","周瑜","司马懿","夏侯惇"};<br />
        //存储图片的数组<br />
    private int [] images = {R.mipmap.liubei,R.mipmap.zhangfei,R.mipmap.zhugeliang,R.mipmap.zhaoyun,<br />
                            R.mipmap.sunquan,R.mipmap.zhouyu,R.mipmap.simayi,R.mipmap.xiahoudun};<br />
    @Override<br />
    protected void onCreate(Bundle savedInstanceState) {<br />
        super.onCreate(savedInstanceState);<br />
        setContentView(R.layout.activity_main);<br />
            //找到控件<br />
        ListView listView  = (ListView) findViewById(R.id.listView);<br />
            //设置适配器<br />
        listView.setAdapter(new MyAdapter(this));<br />
            //设置点击事件<br />
        listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {<br />
            @Override<br />
            public void onItemClick(AdapterView&lt;?&gt; parent, View view, int position, long id) {<br />
                    //弹出吐司<br />
                Toast.makeText(MainActivity.this, "点我了？我是"+names[position], Toast.LENGTH_SHORT).show();<br />
            }<br />
        });<br />
    }

    /**<br />
     * 自定义适配器，继承BaseAdapter<br />
     */<br />
    class MyAdapter extends BaseAdapter{<br />
            //维护一个上下文，为了得到布局填充器<br />
        private Context context;<br />
            //维护一个布局填充器，为了得到每个item 的布局<br />
        private LayoutInflater layoutInflater;

        public MyAdapter(Context context){<br />
                //通过构造方法获取布局填充器对象<br />
            layoutInflater = LayoutInflater.from(context);<br />
        }<br />
        //该方法是总共有多少个item<br />
        @Override<br />
        public int getCount() {<br />
            return names.length;<br />
        }<br />
        //该方法是得到每个item的值<br />
        @Override<br />
        public Object getItem(int position) {<br />
            return names[position];<br />
        }<br />
        //该方法是得到每个item的id<br />
        @Override<br />
        public long getItemId(int position) {<br />
            return position;<br />
        }<br />
        //该方法是获得视图，也是这些里面最重要的方法<br />
        @Override<br />
        public View getView(int position, View convertView, ViewGroup parent) {<br />
                //首先，我们通过布局填充器获得item的布局<br />
            View view = layoutInflater.inflate(R.layout.item_layout,null);<br />
                //根据item的布局找到图片<br />
            ImageView iv_icon = (ImageView) view.findViewById(R.id.iv_icon);<br />
                //根据item的布局找到标题<br />
            TextView tv_title  = (TextView) view.findViewById(R.id.tv_title);<br />
                //根据item的布局找到内容<br />
            TextView tv_content = (TextView) view.findViewById(R.id.tv_content);<br />
                //设置图片源（也就是我们装图片的那个数组）<br />
            iv_icon.setImageResource(images[position]);<br />
                //设置标题文字<br />
            tv_title.setText(names[position]);<br />
                //设置内容文字<br />
            tv_content.setText("我是"+names[position]);<br />
                //返回item的布局<br />
            return view;<br />
        }<br />
    }<br />
}</pre>
</div>
<p>　　我们通过上面的代码，再来理一理思路。</p>
<p>　　<strong>首先，我们准备资源。</strong></p>
<div>
<pre class="prettyprint linenums">     //存储文字的数组<br />
    private String [] names ={"刘备","张飞","诸葛亮","赵云","孙权","周瑜","司马懿","夏侯惇"};<br />
        //存储图片的数组<br />
    private int [] images = {R.mipmap.liubei,R.mipmap.zhangfei,R.mipmap.zhugeliang,R.mipmap.zhaoyun,<br />
                            R.mipmap.sunquan,R.mipmap.zhouyu,R.mipmap.simayi,R.mipmap.xiahoudun};</pre>
</div>
<p>　　<strong>然后，我们通过findViewById来找到我们需要的控件，这里就是ListView</strong></p>
<div>
<pre class="prettyprint linenums">  //找到控件<br />
        ListView listView  = (ListView) findViewById(R.id.listView);</pre>
</div>
<p>　　<strong>然后，我们设置适配器</strong></p>
<div>
<pre class="prettyprint linenums"> //设置适配器<br />
        listView.setAdapter(new MyAdapter(this));</pre>
</div>
<p>　　这里出现了MyAdapter，一会进行讲解</p>
<p>　　<strong>然后，我们通过匿名内部类来获得点击事件</strong></p>
<div>
<pre class="prettyprint linenums">     //设置点击事件<br />
        listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {<br />
            @Override<br />
            public void onItemClick(AdapterView&lt;?&gt; parent, View view, int position, long id) {<br />
                    //弹出吐司<br />
                Toast.makeText(MainActivity.this, "点我了？我是"+names[position], Toast.LENGTH_SHORT).show();<br />
            }<br />
        });</pre>
</div>
<p>　　接下来，我们就来看一下<strong>MyAdapter</strong>这个<strong>自定义适配器</strong></p>
<p>　　我们的适配器有很多，但是为什么我们偏偏选择继承<strong>BaseAdapter</strong>呢？因为它<strong>灵活</strong></p>
<p>　　我们继承BaseAdapter之后，我们<strong>需要重写四个方法</strong>。</p>
<p>　　在重写那四个方法之前，我们来介绍一下<strong>布局填充器</strong>。所谓的布局填充器就是<strong>通过XML文件去获得里面的布局</strong></p>
<p>　　我们在这里<strong>通过布局填充器去获得item的布局</strong>，但是呢，布局填充器<strong>需要一个上下文作为参数</strong>。</p>
<p>　　<strong>所以</strong>，我们先<strong>维护一个上下文</strong>和 <strong>一个布局填充器</strong>，并<strong>通过构造方法获得布局填充器的对象</strong></p>
<div>
<pre class="prettyprint linenums">    //维护一个上下文，为了得到布局填充器<br />
        private Context context;<br />
            //维护一个布局填充器，为了得到每个item 的布局<br />
        private LayoutInflater layoutInflater;

        public MyAdapter(Context context){<br />
                //通过构造方法获取布局填充器对象<br />
            layoutInflater = LayoutInflater.from(context);<br />
        }</pre>
</div>
<p>　　然后，我们来看看<strong>重写的那四个方法</strong></p>
<p>　　　<strong>　1.</strong></p>
<div>
<pre class="prettyprint linenums">//该方法是总共有多少个item<br />
        @Override<br />
        public int getCount() {<br />
            return names.length;<br />
        }</pre>
</div>
<p>　　　<strong>　2.</strong></p>
<div>
<pre class="prettyprint linenums">//该方法是得到每个item的值<br />
        @Override<br />
        public Object getItem(int position) {<br />
            return names[position];<br />
        }</pre>
</div>
<p>　　　<strong>　3.</strong></p>
<div>
<pre class="prettyprint linenums">//该方法是得到每个item的id<br />
        @Override<br />
        public long getItemId(int position) {<br />
            return position;<br />
        }</pre>
</div>
<p>　　　<strong>　4.</strong></p>
<div>
<pre class="prettyprint linenums">//该方法是获得视图，也是这些里面最重要的方法<br />
        @Override<br />
        public View getView(int position, View convertView, ViewGroup parent) {<br />
                //首先，我们通过布局填充器获得item的布局<br />
            View view = layoutInflater.inflate(R.layout.item_layout,null);<br />
                //根据item的布局找到图片<br />
            ImageView iv_icon = (ImageView) view.findViewById(R.id.iv_icon);<br />
                //根据item的布局找到标题<br />
            TextView tv_title  = (TextView) view.findViewById(R.id.tv_title);<br />
                //根据item的布局找到内容<br />
            TextView tv_content = (TextView) view.findViewById(R.id.tv_content);<br />
                //设置图片源（也就是我们装图片的那个数组）<br />
            iv_icon.setImageResource(images[position]);<br />
                //设置标题文字<br />
            tv_title.setText(names[position]);<br />
                //设置内容文字<br />
            tv_content.setText("我是"+names[position]);<br />
                //返回item的布局<br />
            return view;<br />
        }</pre>
</div>
<p>　　在这四个方法中<strong>getView方法</strong>是最重要的方法，<strong>主要的逻辑都在这里</strong>。</p>
<p>　　我们先<strong>通过布局填充器获得我们的布局</strong>，<strong>并通过布局获得控件</strong>，然后<strong>设置每个控件的值</strong>，最后<strong>返回这个item的布局</strong></p>
<p>我们来一起看一下<strong>运行的结果</strong>吧</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1070971/201612/1070971-20161206005234726-165959367.gif" /></p>
<p>　　这样，我们这个简单的listView就完成了</p>
<p><strong>让程序写入生命，将代码融入灵魂</strong></p>
<p>　　　　　　　　　　　　　　　　　　　　<strong>-------smile、zj</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qworgy9.html">Java四种线程池的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq463dn8.html">&lbrack;转&rsqb;SQL Server 高性能写入的一些总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rrl1e9.html">MACOS无限试用Cornerstone的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd7km0q.html">HTML5中的canvas基本概念及绘图</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2r5139.html">小白科普之JavaScript的JSON</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z45pz9.html">codeforces 691D Swaps in Permutation DFS</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mjv7gq.html">CruiseControl&period;NET &colon; Configuration Preprocessor</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdxdr38.html">安装Ubuntu 14&period;04后要做的5件事情</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvyv5oq.html">sizeof&lpar;int &ast;&rpar; 和 sizeof&lpar;int&rpar;型的大小问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mex552q.html">Struts简介、原理及简单实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jeg038.html">修改MYSQL的默认连接时长</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj6x3lq.html">Python3中列表字符串转数字</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5wm3eq.html">Units in Android</a>
		</li>
						<li><a href="https://www.batexi.com/a/960gmmj9.html">&lpar;转&rpar;Linux的用户和用户组管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllgyg0q.html">团队作业之Rookie also want to fly</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4p0oj9.html">HTTP笔记（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2573rxq.html">vs code 插件收集</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppn37y9.html">在mvc视图中实现rdlc报表展示</a>
		</li>
						<li><a href="https://www.batexi.com/a/9630ee49.html">php实现文件下载代码一例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlo2pk1q.html">rgba透明的兼容处理</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8e1wo0k9.html">C语言-简单哈希表（hash table）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1wo7e9.html">关于如果修改 ie 浏览器 文本模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okygnl9.html">机器学习&amp;mdash&semi;&amp;mdash&semi;Logistic回归</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mdd01q.html">matplotlib绘制三维图</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdw4nr8.html">Struts2运行流程分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z4woz9.html">修复Debian（Ubuntu）Grub2 引导</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vykxo8.html">【转】UIBezierPath精讲</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdwxwr8.html">Java封装 properties文件操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjgerk9.html">HDU 5776 sum &lpar;思维题&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k12lvj9.html">C语言经典算法100例（一）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
